unit GraObj;

{$mode objfpc}{$H+}

interface

 uses  Classes, Controls, SysUtils, TypInfo, Types, LCLType, Graphics, LCLIntf,
      Forms, StdCtrls,  BGRABitmapTypes, BGRABitmap, //aro_types, LMessages,
      aro_graphic_, aro_classes;
type
  TAroGraObj = class(TCustomControl)
  private
       FAlignment : TAlignment;
       //FOnSpaZeiClkEvent: TSpaZeiEvent;
       //FOnSpaZeiDclkEvent: TSpaZeiEvent;
       procedure SetAlignment(const Value : TAlignment);
       procedure SetAktu(a : Boolean);
  protected
       FAroBM : TAroDib;
       FFirst  : Boolean;
       FFirstAdj : Boolean;
       FGesBr  : integer;
       FGesHo  : integer;
       FNoAktu : Boolean;
       FColor  : DWORD;
       FAnzeigeOben : integer;
     class procedure WSRegisterClass; override;
     procedure AdjustClientRect(var aRect: TRect); override;
     {   //class function GetControlClassDefaultSize: TSize; override;

       procedure ScrollBarVertChange(Sender: TObject);
       function  MouseEv(Message: TLMMouse; var Zei : integer): integer;
       procedure WMLButtonUp(var Message: TLMLButtonUp); message LM_LBUTTONUP;
       procedure WMLButtonDBLCLK(var Message: TLMLButtonDblClk); message LM_LBUTTONDBLCLK;
       procedure SetScrollBars (const Value: TScrollStyle);      }
  public
    constructor Create(TheOwner: TComponent); override;
    procedure Paint; override;
       property Alignment: TAlignment read FAlignment write SetAlignment default taCenter;
       property Align default alNone;
       property TabStop default False;
     published
       property Aktusperre : Boolean read FNoAktu write SetAktu default false; // um unnötige BS - Ausgabe vermeiden
       property AroBM : TAroDib read FAroBM; // um unnötige BS - Ausgabe vermeiden
     end;

implementation

constructor TAroGraObj.Create(TheOwner : TComponent);
begin
  inherited Create (TheOwner);
  FFirst := false;
  FFirstAdj := false;
  FGesBr := 1;
  FCompStyle:= csPanel;
  ControlStyle := ControlStyle + [csAcceptsControls, csCaptureMouse,
    csClickEvents, csSetCaption, csDoubleClicks, csReplicatable,
    csNoFocus, csAutoSize0x0, csParentBackground]
    - [csOpaque]; // we need the default background
  FColor := $FFFFFFFF; //clWhite; // { $ifdef UseCLDefault}clDefault{ $else}clBtnFace{ $endif};
  //with GetControlClassDefaultSize do SetInitialBounds(200, 200, CX, CY);
  UseDockManager := True;
  AccessibleRole := larGroup;
end;

procedure TAroGraObj.SetAktu(a : Boolean);
begin
  FNoAktu := a;
  if a = false then Paint;
end;

procedure TAroGraObj.SetAlignment(const Value: TAlignment);
begin
  if FAlignment <> Value then
  begin
    FAlignment := Value;
    Invalidate;
  end;
end;

procedure TAroGraObj.Paint;
begin
  FAroBM.Draw(Canvas,0, 0, Width , Height , 0,0);
  inherited Paint;
end;

procedure TAroGraObj.AdjustClientRect(var aRect: TRect);
begin
  inherited AdjustClientRect(aRect);
  if FFirstAdj = false then begin
    FFirstAdj := true;
    FAroBM := TAroDib.Create(Width , Height);
    FAroBM.Clear(clRed);
    FAroBM.SetStdFont(20, false);
  end;
end;

class procedure TAroGraObj.WSRegisterClass;
begin
  inherited WSRegisterClass;
end;

end.



var i, x, yy : integer;
begin
  if FFirst then exit;  // nur einmal aifrufen !!!!
  FFirst := true;
  FGesBr := 0;
  for i := 1 to FSpaAnz do begin
    FPSpaRecAr^[i].Spa_Li := FGesBr +1;
    inc(FGesBr, FPSpaRecAr^[i].Spa_Br +1);
  end;
  Width := FGesBr;
  FGesHo := FCellHoch * FZeiAnz + FZeiAnz +1;
  AroBM := TAroDib.Create(FGesBr , FGesHo); //, BGRAWhite
  AroBM.Clear(clWhite);
  AroBM.SetStdFont(24, false);
  AroBM.LineHor(0, 0, FGesBr, clSilver);
  yy :=0 ;
  for i := 1 to FZeiAnz do begin
    inc(yy, FCellHoch +1);
   // AroBM.LineHor(0, yy, FGesBr, clSilver);
  end;
  AroBM.LineHor(0, yy, FGesBr, clSilver);
  for i := 1 to FSpaAnz  do begin
    x := FPSpaRecAr^[i].Spa_Li -1;
   // AroBM.LineVert(x, 0, yy, clSilver);
  end;
  AroBM.LineVert(FGesBr, 0, yy, clSilver);
end;

    for i := 1 to 32 do DrawCell(1,i, clWhite, clBlack, ZiffAr[i]);
    ClrRect(2,3 , clRed);
    ClrRect(2,4 , clMaroon );
    ClrRect(2,5 , clGreen );
    ClrRect(2,6 , clOlive );
    ClrRect(2,30 , clNavy);
    ClrRect(2,31 , clPurple );

    AroBM.DrawTextLi(35, 2, 0,'Aro Text'#139#135#136#13);
    AroBM.DrawTextRe(FPSpaRecAr^[5].Spa_Li -3, 20, 0,'Aro Texte');
    AroBM.DrawTextRe(FPSpaRecAr^[5].Spa_Li -3, 30, 0,'Aro e');
    AroBM.Frame3d(40, 44, 30, 16, Ra_Ob, Mi_, Ra_Un);
    AroBM.DrawEllipseFillHQ(130, 290, 281, 181, clRed);

    //StrCopy2St(ss, ProPfad, 'GrauButBl1.bmp');
    //BM := TAroDib.CreateFromBM(ss);
    StrCopy2St(ss, ProPfad, 'but.agf');
    BM := TAroDib.CreateFromAGF(ss);
    //BM.SaveToAGF(ss);

    BM.CopyToTAroDib(AroBM,  30, 200, 0,0, 39,39);   //ZLi, ZOb, QLi, QOb, QBr, QHo : Integer);
    BM.CopyEckenToTAroDib(AroBM,  30, 300,  50, 50);

  //  AroBM.DrawVollKreis(230, 200, 181, 181, clRed);
    {BGRA := AroBM.GetBGRABitmap;
    AroBM.CopyToBGRA;
    BGRA.FillEllipseAntialias(240,240,80,80,clRed);
    AroBM.CopyFromBGRA;
    AroBM.BGRAFree;  }

 {   y := (5 -1 ) * FCellHoch + 5-2;
    AroBM.DrawTextZentr(FPSpaRecAr^[5].Spa_Li, y, FPSpaRecAr^[5].Spa_Br, FCellHoch, clRed, 'AAAAAAA');


    AroBM.SetStdFont(12,False);
    AroBM.SetStdFont(14,False);
    AroBM.SetStdFont(11,False);
   //  StrCopy2St(ss, ProPfad, 'tt.JPG');
    StrCopy2St(ss, ProPfad, 'b_b.bmp');
    BM := TAroDib.CreateOverBGRA(ss);
    BM.CopyToTAroDib(AroBM,  30, 200, 0,0, 100,100);
    BM.Free;  }

    {
    clBlack   = TColor($000000);
    clTeal    = TColor($808000);
    clGray    = TColor($808080);
    clSilver  = TColor($C0C0C0);
    clRed     = TColor($0000FF);
    clLime    = TColor($00FF00);
    clYellow  = TColor($00FFFF);
    clBlue    = TColor($FF0000);
    clFuchsia = TColor($FF00FF);
    clAqua    = TColor($FFFF00);
    clLtGray  = TColor($C0C0C0); }

function  TAroGraObj.MouseEv(Message: TLMMouse; var Zei : integer): integer;
var MP: TPoint;
    i, yy, y : integer;
begin
  MP := GetMousePosFromMessage(Message.Pos);
  for i := FSpaAnz downto 1 do begin
    if MP.x > FPSpaRecAr^[i].Spa_Li then begin
      Result := i;
      break;
    end;
  end;
  yy := FGesHo -  -1;
  y := MP.y  + FAnzeigeOben;
  for i := FZeiAnz downto 1 do begin
    dec(yy, FCellHoch +1);
    if y > yy then begin
      Zei := i;
      break;
    end;
  end;
end;

procedure TAroGraObj.WMLButtonUp(var Message: TLMLButtonUp);
var Spa, Zei : integer;
begin
  if Assigned(FOnSpaZeiClkEvent) then begin
    {$HINTS OFF} Spa := MouseEv(Message, Zei); {$HINTS ON}
    FOnSpaZeiClkEvent(self, Spa, Zei);
 end;
end;

procedure TAroGraObj.WMLButtonDBLCLK(var Message: TLMLButtonDblClk);
var Spa, Zei : integer;
begin
  if Assigned(FOnSpaZeiDClkEvent) then begin
    {$HINTS OFF} Spa := MouseEv(Message, Zei); {$HINTS ON}
    FOnSpaZeiDClkEvent(self, Spa, Zei);
  end;
end;





Const
  Ra_Ob = $FFE0E0E0;
  Mi_   = $FFD0D0D0;
  Ra_Un = $FFA0A0A0;



procedure TAroGraObj.ClrRect(Spa, Zei, color_ : Integer);
var y : integer;
begin
  dec(Zei);
  y := Zei * FCellHoch + Zei+1;
  With FPSpaRecAr^[spa] do begin
    AroBM.ClearBereich(Spa_Li, Y, Spa_Br,  FCellHoch, color_);
  end;
end;

procedure TAroGraObj.DrawCell(Spa, Zei : Integer; HgCol, VGCol : DWORD; Txt : PAnsiChar);
var x, y : integer;
begin
  y := (Zei -1 ) * FCellHoch + Zei-2;
  x := FPSpaRecAr^[Spa].Spa_Li + 5;
  if HgCol <> clWhite then begin //

  end;
  ClrRect(Spa, Zei, BGRAWhite);
  AroBM.DrawTextLi(x,  y, 0, Txt); //  VGCol    HgCol VGCol or $FF000000   BGRABlack
  if FNoAktu = false then Paint;
end;

end.
    {$WARNINGS OFF}
    {$WARNINGS ON}


