unit aro_graphic;

{$mode objfpc}{$H+}
{$ASMmode intel}

interface

uses
  Classes, SysUtils, aro_classes, aro_types ,Graphics, lcltype,// BaseUnix,
  LCLIntf, types, BGRABitmapTypes, BGRABitmap;

type

  PAroFontSatz = ^TAroFontSatz;
  TAroFontSatz = packed Record //16 Byte
     RFS_pitch : Byte;
     RFS_spa   : Byte;
     RFS_zei   : Byte;
     RFS_res   : Byte;
     RFS_x     : SmallInt;
     RFS_y     : SmallInt;
     RFS_advx  : SmallInt;
     RFS_BuLen : SmallInt;
     RFS_buf   : integer;
   end;

  PColorSatz = ^ColorSatz;
  ColorSatz = packed record
    case Integer of
    0: ( CS_red,CS_green,CS_blue,CS_alpha : Byte;);
    1: ( CS_li : integer);
    2: ( CS_DW : DWORD);
  end;

  PFontBitmap = ^TFontBitmap;
  TFontBitmap = record
    height, width, pitch,
    x,y, advanceX, advanceY : integer;
    data : PByteArray;
  end;

PFontFile = ^TFontFile;
TFontFile = class(TRecFile)
  private
  protected
  public
    constructor CreateFil(FileName: PAnsiChar; Mode : Word);
    function	FontCharWrite(Pos : Integer; PFS : PAroFontSatz): DWORD;
    function	CharRead(Pos : Integer): TAroFontSatz;
	end;

 FontSatz = Packed record
    FS_Name : PAnsiChar;
    FS_Hoch : Integer;
    FS_Bold : Boolean;
    FS_Font : TFontFile;
  end;

  FontAr = Array [1.. 20000] of FontSatz;
  PFontAr = ^FontAr;

TAroDib = class(TObject)
  private
      FBiBr, FBiHo : word;
      FBiPOI : PColorSatz;
      FByteAnz, FPixAnz, FByteZeile  : Integer; //Anz Byte ges; Anz Pixel ges;  Anz Byte pro Zeile;
      FFontHoch : Integer; // Info für DrawTextZentr erforderlich !
      FTextfarbe : ColorSatz;
      FAktFond : TFontFile;
      FBGRA : TBGRABitmap;
    procedure DrawChar (PSF : PAroFontSatz);
    procedure PixelBlend (Ziel, Quelle : PColorSatz);
    function  GetTextSize(Txt : PAnsiChar): Integer;
    procedure FillZeileInc(Var Ziel : PColorSatz; Farbe, Anz, Rest : DWORD);
    procedure FillZeile(var Ziel :  PColorSatz; Farbe, Anzahl : integer);
    procedure FillZeilelinks(var Ziel : PColorSatz; Farbe, Anz : DWORD);
    procedure FillSpalte(var Ziel :  PColorSatz; Farbe, Anzahl, Rest : integer);
    procedure FillSpalteOben(var Ziel :  PColorSatz; Farbe, Anzahl, Rest : integer);
    procedure CopyZeile(var Ziel, Quelle :  PColorSatz;  Anzahl, RestZ, RestQ : integer);
  protected
  public
    constructor Create(Br, Ho : Word); virtual;
    constructor CreateFromAGF(Name : PAnsiChar); virtual;
    constructor CreateFromBM(Name : PAnsiChar); virtual;
    constructor CreateOverBGRA(Na : PAnsiChar); virtual;
    destructor Destroy;  override;
    procedure Draw(ACanvas : TCanvas);  overload;
    procedure Draw(ACanvas : TCanvas; QLi, QOb, QBr, QHo, ZLi, ZOb : integer);  overload;
    procedure SetFont(hoch : integer; Bold :Boolean; Na :PAnsiChar);
    procedure SetStdFont(hoch : integer; Bold :Boolean);

    procedure Clear(F : DWord);
    procedure ClearBereich(Li, Ob, Br, Ho, Farbe : integer); //overload;
    procedure LineHor(Li, Ob, Br, Farbe : integer);
    procedure LineVert(x, y, Ho, Farbe : integer);
    procedure HorizontalMove(alt, neu : integer);
    procedure Frame3d(x, y, Br, Ho, Cl_o, Cl_mi, CL_u : integer);
    procedure CopyToTAroDib(Ziel : TAroDib; ZLi, ZOb, QLi, QOb, QBr, QHo : Integer);
    procedure CopyEckenToTAroDib(Ziel : TAroDib; ZLi, ZOb, ZBr, ZHo : Integer);
    procedure DrawEllipseFill(Li, Ob, Br, Ho, Farbe : Integer);
    procedure DrawEllipseFillHQ(Li, Ob, Br, Ho, Farbe : Integer);
    procedure SaveToAGF(Name : PAnsiChar);
    procedure SaveToBM(Name : PAnsiChar);

    function  GetBGRABitmap : TBGRABitmap;
    procedure BGRAFree;
    procedure CopyToBGRA;
    procedure CopyFromBGRA;

    procedure DrawTextLi(atx,aty, Farbe:integer; atext:string);   overload;
    procedure DrawTextLi(atx,aty, Farbe:integer; atext:PAnsiChar);   overload;
    procedure DrawTextRe(Re_x,aty, Farbe:integer; atext:string);   overload;
    procedure DrawTextRe(Re_x,aty, Farbe:integer; atext:PAnsiChar);   overload;
    procedure DrawTextZentr(Li, Ob, Br, Ho, Farbe:integer; atext:string);   overload;
    procedure DrawTextZentr(Li, Ob, Br, Ho, Farbe:integer; atext:PAnsiChar);    overload;
    property Width  : Word read FBiBr;
    property Height : Word read FBiHo;
end;

TAroDateiDib = class(TAroDib)  // Wenn zB Hintergrundbilder verändert wurden aber
  private                      // im Originalzustand wieder benötigt werden,
      FDat : TAroFile;         // muss man die Kopie des Originals nicht im RAM halten
  protected                    // die Datei bleibt geöffnet
  public
    constructor CreateFromAGF(Name : PAnsiChar); reintroduce;
    destructor Destroy;  override;
    procedure Nachladen;
end;


  Function  GetFont(Na : PAnsiChar;  H : Integer; Bold :Boolean): TFontFile;

var FondPfad  : PAnsiChar;

implementation

uses ExtCtrls, graphtype, Forms, gdk2, gtk2def;

Var FontAnz, FontMax : Integer;
    FontListe : PFontAr;

//TFontFile //TFontFile //TFontFile //TFontFile //TFontFile //TFontFile //TFontFile //TFontFile //TFontFile //TFontFile //TFontFile //TFontFile
constructor TFontFile.CreateFil(FileName: PAnsiChar; Mode : Word);
begin
  Inherited CreateFil(FileName, Mode, sizeof(TAroFontSatz));
  if Mode = Op_NeuAnlegen then begin
    SetSize(256 * sizeof(TAroFontSatz));  // platz für records reservieren
  end;
end;

function TFontFile.FontCharWrite(Pos : Integer; PFS : PAroFontSatz): DWORD;
begin
  PFS^.RFS_buf := Seek_EOF; //Position für neuen Bmp - zum abspeichern
  RecSeek(Pos);
  Result := RecWrite(PFS^);
  Seek_EOF; //Position für neuen Bmp - Datenbereich
end;

function TFontFile.CharRead(Pos : Integer): TAroFontSatz;
begin
  RecSeek(Pos);
  {$HINTS OFF}
  RecRead(result);
  {$HINTS ON}
end;

//TAroDib //TAroDib //TAroDib //TAroDib //TAroDib //TAroDib //TAroDib //TAroDib //TAroDib //TAroDib //TAroDib //TAroDib //TAroDib //TAroDib //TAroDib
constructor TAroDib.Create(Br, Ho : Word);
begin
  FBiBr := Br;
  FBiHo := Ho;
  FPixAnz := Br * Ho;
  FByteZeile := Br * 4;
  FByteAnz := FPixAnz * 4;
  Getmem(FBiPOI, FByteAnz);
end;

constructor TAroDib.CreateFromAGF(Name : PAnsiChar);
var Dat : TAroFile;
begin
  Dat := TAroFile.CreateFil(Name, Op_Open);
  Dat.Read(FByteAnz,4);
  Dat.Read(FBiBr,2);
  Dat.Read(FBiHo,2);
  Getmem(FBiPOI, FByteAnz);
  Dat.Read(FBiPOI^, FByteAnz);
  dat.Free;
  FPixAnz := FBiBr * FBiHo;
  FByteZeile := FBiBr * 4;
  FByteAnz := FPixAnz * 4;
end;

constructor TAroDib.CreateFromBM(Name : PAnsiChar);
var Dat : TAroFile;
    header  : TBITMAPFILEHEADER;
    bmiH_   : TBitmapInfoHeader;
    bmiC_   : array[0..0] of TRGBTriple;
    l, i, k, Rest : longint;
    BS : ByteSatz;
    BiDat : PColorSatz;
begin
  {$HINTS OFF}
  Dat := TAroFile.CreateFil(Name, Op_Open);
  Dat.Read(header,sizeof(TBITMAPFILEHEADER));//Header lesen
  if (header.bfType=$4D42) then begin//Typ Ok
    Dat.ReadInt(bmiH_); // ln TBitmapInfoHeader;
    l := bmiH_.biSize - 4;
    if l > 36 then l := 36;
    Dat.Read(bmiH_.biWidth, l);  //BITMAPINFOHEADER-Struktur lesen
    With bmiH_ do begin
      FBiBr := biWidth; //Breite hloen
      FBiHo := biHeight; //Höhe hloen
    end;
    case bmiH_.biBitCount of
      24: begin
            Rest := (FBiBr *3) and 3;
            if Rest <> 0 then Rest := 4 - Rest;
            FByteAnz := FBiBr * FBiHo * 4;
            Getmem(FBiPOI, FByteAnz);
            BiDat := FBiPOI;
            inc(BiDat, FBiBr * FBiHo);
            for i := 1 to FBiHo do begin
              dec(BiDat, FBiBr);
              for k := 1 to FBiBr do begin
                BS.li:= 0;
                Dat.Read(BS , 3); //Farbpalette lesen  BS
                BiDat^.CS_blue :=  BS.B1;
                BiDat^.CS_green := BS.B2;
                BiDat^.CS_red :=   BS.B3;
                inc(BiDat);
              end;
              if Rest > 0 then Dat.Read(BS , Rest); //Farbpalette lesen  BS
              dec(BiDat, FBiBr);
            end;
          end;
      32: begin
            FByteAnz := FBiBr * FBiHo * 4;
            Getmem(FBiPOI, FByteAnz);
            Dat.Read(bmiC_, bmiH_.biClrUsed * 4); //Farbpalette lesen
            Dat.seek(header.bfOffBits);
            BiDat := FBiPOI;
            inc(BiDat, FBiBr * FBiHo);
            for i := 1 to FBiHo do begin
              dec(BiDat, FBiBr);
              for k := 1 to FBiBr do begin
                BS.li:= 0;
                Dat.Read(BS , 4); //Farbpalette lesen  BS
                BiDat^.CS_blue :=  BS.B1;
                BiDat^.CS_green := BS.B2;
                BiDat^.CS_red :=   BS.B3;
                BiDat^.CS_alpha:= $FF;
                inc(BiDat);
              end;
              dec(BiDat, FBiBr);
            end;
          end;
       end;
  end;
  {$HINTS ON}
  dat.Free;
  FPixAnz := FBiBr * FBiHo;
  FByteZeile := FBiBr * 4;
  FByteAnz := FPixAnz * 4;
end;

constructor TAroDib.CreateOverBGRA(Na : PAnsiChar);
var temp: TBGRABitmap;
begin
  if TestDatei(Na) then begin //datei existiert
    temp := TBGRABitmap.Create(Na);
    FBiBr := temp.Width;
    FBiHo := temp.Height;
    FPixAnz := FBiBr * FBiHo;
    FByteZeile := FBiBr * 4;
    FByteAnz := FPixAnz * 4;
    Getmem(FBiPOI, FByteAnz);
    move(temp.DataByte^, FBiPOI^, FByteAnz);
    temp.Free;
  end else begin  // datei existiert nicht
    FBiBr := 1000;   // leeres Dib erzeugen, um Abstürze zu Verhindern
    FBiHo := 1000;
    FPixAnz := 1000000;
    FByteZeile := 4000;
    FByteAnz := 4000000;
    Getmem(FBiPOI, FByteAnz);
    Clear($FF00FF); // Lila um auf Fehler hinzuweisen
  end;
end;

destructor TAroDib.Destroy;
begin
  if FBGRA <> Nil then FBGRA.Free;
  Freemem(FBiPoi, FByteAnz);
  Inherited Destroy;
end;

procedure TAroDib.FillZeileInc(var Ziel : PColorSatz; Farbe, Anz, Rest : DWORD);    assembler;
Var P1  : Pointer;
asm
  MOV P1, RSI  //Übergabeadresse merken
  MOV RDI, [RSI]
  MOV   RAX, RDX  // Farbe
  //RCX - Anzahl
  repne STOSD
  shl   R8, 2  // Rest
  ADD   RDI, R8
  MOV R8, P1
  MOV [R8], RDI
end;

procedure TAroDib.FillZeile(var Ziel :  PColorSatz; Farbe, Anzahl : integer); assembler;
Var P1  : Pointer;
asm
  MOV P1, RSI  //Übergabeadresse merken
  MOV RDI, [RSI]
  MOV   RAX, RDX  // Farbe
  repne STOSD
  MOV R8, P1
  MOV [R8], RDI
end;

procedure TAroDib.FillZeilelinks(var Ziel : PColorSatz; Farbe, Anz : DWORD); assembler;
Var P1  : Pointer;
asm
  MOV P1, RSI  //Übergabeadresse merken
  MOV RDI, [RSI]
  MOV   RAX, RDX  // Farbe
  STD
  repne STOSD
  CLD
  MOV R8, P1
  MOV [R8], RDI
end;

procedure TAroDib.FillSpalte(var Ziel :  PColorSatz; Farbe, Anzahl, Rest : integer); assembler;
Var P1  : Pointer;
asm   MOV P1, RSI  //Übergabeadresse merken
      MOV RDI, [RSI]
      shl   R8, 2  // Rest
@@1:  MOV [RDI], EDX //Farbe
      ADD RDI, R8
      DEC RCX
      JNZ		@@1
      MOV R8, P1
      MOV [R8], RDI
end;

procedure TAroDib.FillSpalteOben(var Ziel :  PColorSatz; Farbe, Anzahl, Rest : integer); assembler;
Var P1  : Pointer;
asm   MOV P1, RSI  //Übergabeadresse merken
      MOV RDI, [RSI]
      shl   R8, 2  // Rest
@@1:  MOV [RDI], EDX //Farbe
      SUB RDI, R8
      DEC RCX
      JNZ		@@1
      MOV R8, P1
      MOV [R8], RDI
end;

procedure TAroDib.CopyZeile(var Ziel, Quelle :  PColorSatz;  Anzahl, RestZ, RestQ: integer); assembler;
Var P1 , P2 : Pointer;
asm
  MOV P1, RSI  //Übergabeadresse merken
  MOV P2, RDX
  MOV RDI, [RSI]
  MOV RSI, [RDX]
  rep movsd
  shl   R8, 2  // Rest Ziel
  ADD   RDI, R8
  shl   R9, 2  // Rest Quelle
  ADD   RSI, R9
  MOV R8, P1
  MOV [R8] , RDI
  MOV R8, P2
  MOV [R8] , RSI
end;

{  Wenn kein Intel64 dann Assembler als Kommentar und den Bereich freigeben !!!!
procedure TAroDib.FillZeileInc(var Ziel : PColorSatz; Farbe, Anz, Rest : DWORD);
Var i  : integer;
begin
  for i := 1 to Anz do begin
    Ziel^.CS_DW:= Farbe;
    inc(Ziel);
  end;
  inc(Ziel, Rest);
end;

procedure TAroDib.FillZeile(var Ziel :  PColorSatz; Farbe, Anzahl : integer);
Var i  : integer;
begin
  for i := 1 to  Anzahl do begin
    Ziel^.CS_DW:= Farbe;
    inc(Ziel);
  end;
end;

procedure TAroDib.FillZeilelinks(var Ziel : PColorSatz; Farbe, Anz : DWORD);
Var i  : integer;
begin
  for i := 1 to  Anz do begin
    Ziel^.CS_DW:= Farbe;
    dec(Ziel);
  end;
end;

procedure TAroDib.FillSpalte(var Ziel :  PColorSatz; Farbe, Anzahl, Rest : integer);
Var i  : integer;
begin
  for i := 1 to  Anzahl do begin
    Ziel^.CS_DW:= Farbe;
    inc(Ziel, Rest);
  end;
end;

procedure TAroDib.FillSpalteOben(var Ziel :  PColorSatz; Farbe, Anzahl, Rest : integer);
Var i  : integer;
begin
  for i := 1 to  Anzahl do begin
    Ziel^.CS_DW:= Farbe;
    dec(Ziel, Rest);
  end;
end;  }

procedure TAroDib.Clear(F : DWord);
Var P : Pointer;
begin
  p := FBiPOI;
  FillZeile(P, F, FPixAnz);
end;
procedure TAroDib.ClearBereich(Li, Ob, Br, Ho, Farbe : integer);
Var ZStart,  Rest, Temp : Integer;
    Zeile : integer;
    ZBuf: PColorSatz;
begin
  if Ob > FBiHo then exit;
  Temp := FBiHo - OB - Ho;
  if Temp < 0 then inc(Ho, Temp); // inc da Temp negativ !!
  ZBuf := FBiPOI;
  ZStart := (Ob * FBiBr) + Li;
  inc(ZBuf, ZStart);
  Rest := FBiBr - Br;
  for Zeile := 1 to Ho do FillZeileInc(ZBuf, Farbe, Br, Rest);
end;

procedure TAroDib.LineHor(Li, Ob, Br, Farbe : integer);
Var ZStart : integer;
    ZBuf: PColorSatz;
begin
  Farbe := Farbe or $FF000000;
  ZBuf := FBiPOI;
  ZStart := (Ob * FBiBr) + Li;
  inc(ZBuf, ZStart);
  FillZeile(ZBuf, Farbe, Br);
end;

procedure TAroDib.LineVert(x, y, Ho, Farbe : integer);
Var ZStart : integer;
    ZBuf: PColorSatz;
begin
  Farbe := Farbe or $FF000000;
  ZBuf := FBiPOI;
  ZStart := (y * FBiBr) + x;
  inc(ZBuf, ZStart);
  FillSpalte(ZBuf, Farbe, ho, FBiBr);
end;

procedure TAroDib.HorizontalMove(alt, neu : integer);
var  Anz, i : Integer;
    PI_alt, PI_Neu : PColorSatz;

begin
  if neu > alt then begin // nach unten verschieben
    Anz := FBiHo - neu -1;
    PI_Neu := FBiPOI;  //PInteger(DataByte);
    INC(PI_Neu, ( FBiHo -1 ) * FBiBr);
    PI_alt := PI_Neu;
    dec(PI_alt, (neu -alt) * FBiBr); //  neu - alt
    for i := 1 to anz do begin
      move(PI_alt^,PI_Neu^ , FByteZeile);
      dec(PI_alt,  FBiBr);
      dec(PI_Neu,  FBiBr);
    end;
  end else begin // nach oben verschieben



  end;
end;

procedure TAroDib.Frame3d(x, y, Br, Ho, Cl_o, Cl_mi, CL_u : integer);
var k, Rest : integer;
    PI :  PColorSatz;
begin
  PI := FBiPOI;
  INC(PI, Y * FBiBr);
  INC(PI, x);
  Rest := FBiBr - Br;
  FillZeileInc(PI, Cl_o, Br, Rest);
  for k := 1 to Ho -2 do begin
    PI^.CS_li := Cl_o;
    INC(PI);
    FillZeile(PI, Cl_mi, Br-2);
    PI^.CS_li := CL_u;
    INC(PI);
    INC(PI, Rest);
  end;
  FillZeile(PI, Cl_u, Br);
end;

procedure TAroDib.CopyToTAroDib(Ziel : TAroDib; ZLi, ZOb, QLi, QOb, QBr, QHo : Integer);
Var Zeile, restQ, RestZ : Word;
    ZBuf, QBuf: PColorSatz;
    i : Integer;
begin
  if ZLi < 0 then begin
    inc(QBr, ZLi);
    ZLi := 0;
  end;
  if ZOb < 0 then begin
    inc(QHo, ZOb);
    ZOb := 0;
  end;
  i := Ziel.FBiBr - ZLi -QBr;
  if i < 0 then inc(QBr ,i);
  i := Ziel.FBiHo - ZOb - QHo;
  if i < 0 then inc(QHo ,i);
  if QBr < 1 then exit;
  if QHo < 1 then exit;

  ZBuf := Ziel.FBiPOI;
  inc(ZBuf, Ziel.FBiBr * ZOb+ ZLi);
  QBuf := FBiPOI;
  inc(QBuf, FBiBr * QOb+ QLi);
  RestQ := FBiBr - QBr;
  RestZ := Ziel.FBiBr - QBr;
  for Zeile := 1 to QHo do begin
    {Move(QBuf^, ZBuf^, QBr *4); // Ohne Assemblercode diese 3 Zeilen verwenden
    inc(QBuf, FBiBr);            // und CopyZeile(ZBuf, QBuf, QBr, restZ, restQ);
    inc(ZBuf, Ziel.FBiBr); }     // als Kommentar ändern
    CopyZeile(ZBuf, QBuf, QBr, restZ, restQ);
  end;
end;

procedure TAroDib.CopyEckenToTAroDib(Ziel : TAroDib; ZLi, ZOb, ZBr, ZHo : Integer);
Var ZBuf, QBuf, Tempbuf : PColorSatz;
    Temp : ColorSatz;
    Zeile, QHalbBr1, QHalbBr2, QHalbHo1, QHalbHo2, ZeiMitte : integer;
begin
  QHalbBr1 := FBiBr shr 1;
  QHalbBr2 := FBiBr - QHalbBr1;
  QHalbHo1 := FBiHo shr 1;
  QHalbHo2 := FBiHo - QHalbHo1;
  ZBuf := Ziel.FBiPOI;
  inc(ZBuf, Ziel.FBiBr * ZOb+ ZLi);
  QBuf := FBiPOI;
  ZeiMitte := ZBr - FBiBr;  // Lücke zwischen oberen Ecken
  for Zeile := 1 to QHalbHo1 do begin
    Move(QBuf^, ZBuf^, QHalbBr1 *4); // linke obere Ecke
    inc (ZBuf, QHalbBr1);
    inc (QBuf, QHalbBr1);
    Temp := QBuf^;
    FillZeile(ZBuf, Temp.CS_DW, ZeiMitte);
    Move(QBuf^, ZBuf^, QHalbBr2 *4);
    inc (QBuf, QHalbBr2);
    inc (ZBuf, Ziel.FBiBr -QHalbBr1- ZeiMitte);
  end;
  Tempbuf := ZBuf;
  dec(Tempbuf, Ziel.FBiBr);
  for Zeile := 1 to (ZHo - FBiHo) do begin
    Move(Tempbuf^, ZBuf^, ZBr *4);  // Zeilen zwischen oberer und unterer Ecke füllen
    inc(ZBuf, Ziel.FBiBr);
  end;
  for Zeile := 1 to QHalbHo2 do begin
    Move(QBuf^, ZBuf^, QHalbBr1 *4); // linke obere Ecke
    inc (ZBuf, QHalbBr1);
    inc (QBuf, QHalbBr1);
    Temp := QBuf^;
    FillZeile(ZBuf, Temp.CS_DW, ZeiMitte);
    Move(QBuf^, ZBuf^, QHalbBr2 *4);
    inc (QBuf, QHalbBr2);
    inc (ZBuf, Ziel.FBiBr -QHalbBr1- ZeiMitte);
  end;
end;

procedure TAroDib.DrawEllipseFill(Li, Ob, Br, Ho, Farbe : Integer);
Var UntBuf, ObBuf,  RU_Buf, LU_Buf, RO_Buf, LO_Buf, MaxPoi: PColorSatz;
    i, c2, a2, Temp, TempL, TempR, Farbe_ : Integer;
    Color_, Color_R, Color_L : ColorSatz;
    HalbHo : Integer;
    b2, bb, Faktor : Single;
begin
  HalbHo := Ho shr 1 ;
  Faktor := Br / Ho;
  c2 := HalbHo * HalbHo;   //c2
  UntBuf := FBiPOI;
  MaxPoi :=  UntBuf;
  inc(MaxPoi, FBiBr * FBiHo);
  inc(UntBuf, ob * FBiBr + li);
  ObBuf := UntBuf;
  Color_.CS_DW := Farbe;
  Farbe_:= Farbe or $FF000000;
  For i := 1 to HalbHo do begin
    RU_Buf := UntBuf;
    LU_Buf := UntBuf;
    RO_Buf := ObBuf;
    LO_Buf := ObBuf;
    a2 := i * i;               //a2
    b2 := c2 - a2;             //b2 = c2 - a2
    bb := (sqrt(b2)) * Faktor; //b  = wurzel aus b2
    Temp := trunc(bb);
    Color_.CS_alpha:= Round(255 * (bb - temp));
    if Temp + Li >= FBiBr then begin
      TempR:= FBiBr - Li ;
      Color_R.CS_DW :=0;
    end else begin
      TempR:= Temp;
      Color_R :=Color_;
    end;
    if Li - Temp < 0 then begin
      TempL:= Li+1;
      Color_L.CS_DW :=0;
    end else begin
      TempL:= Temp;
      Color_L :=Color_;
    end;
    if ObBuf > FBiPOI then begin
      FillZeile(RO_Buf, Farbe_, tempR);
      if Color_R.CS_alpha > 20 then PixelBlend (PColorSatz(RO_Buf), @Color_R);
    end;
    if UntBuf < MaxPoi then begin
      FillZeile(RU_Buf, Farbe_, tempR);
      if Color_R.CS_alpha > 20 then PixelBlend (PColorSatz(RU_Buf), @Color_R);
    end;
    if ObBuf > FBiPOI then begin
      FillZeilelinks(LO_Buf, Farbe_, tempL);
      if Color_L.CS_alpha > 20 then PixelBlend (PColorSatz(LO_Buf), @Color_L);
    end;
    if UntBuf < MaxPoi then begin
      FillZeilelinks(LU_Buf, Farbe_, tempL);
      if Color_L.CS_alpha > 20 then PixelBlend (PColorSatz(LU_Buf), @Color_L);
    end;
    inc(UntBuf, FBiBr);
    dec(ObBuf, FBiBr);
  end;
end;

procedure TAroDib.DrawEllipseFillHQ(Li, Ob, Br, Ho, Farbe : Integer);
Var UntBufL, UntBufR, ObBufR, ObBufL,  RU_Buf, LU_Buf, RO_Buf, LO_Buf, MaxPoi: PColorSatz;
    i, c2, a2, Temp, TempL, TempR, TempU, TempO, Farbe_ : Integer;
    Color_, Color_R, Color_L, Color_O, Color_U : ColorSatz;
    Stufe1,  HalbHo: Integer;
    a2_, b2, bb, Faktor : Single;
begin
  HalbHo := Ho shr 1 ;
  Stufe1 := round (HalbHo * 0.75);
  Faktor := Br / Ho;
  c2 := HalbHo * HalbHo;   //c hoch 2
  UntBufL := PColorSatz(FBiPOI);
  MaxPoi :=  UntBufL;
  inc(MaxPoi, FBiBr * FBiHo);
  inc(UntBufL, ob * FBiBr + li);
  ObBufL := UntBufL;
  Color_.CS_DW := Farbe;
  Farbe_:= Farbe or $FF000000;
  For i := 1 to Stufe1 do begin
    RU_Buf := UntBufL;
    LU_Buf := UntBufL;
    RO_Buf := ObBufL;
    LO_Buf := ObBufL;
    a2 := i * i;               //a2
    b2 := c2 - a2;             //b2 = c2 - a2
    bb := (sqrt(b2)) * Faktor; //b  = wurzel aus b2
    Temp := trunc(bb);
    Color_.CS_alpha:= Round(255 * (bb - temp));
    if Temp + Li >= FBiBr then begin
      TempR:= FBiBr - Li ;
      Color_R.CS_DW :=0;
    end else begin
      TempR:= Temp;
      Color_R :=Color_;
    end;
    if Li - Temp < 0 then begin
      TempL:= Li+1;
      Color_L.CS_DW :=0;
    end else begin
      TempL:= Temp;
      Color_L :=Color_;
    end;
    if ObBufL > FBiPOI then begin
      FillZeile(RO_Buf, Farbe_, tempR);
      if Color_R.CS_alpha > 20 then PixelBlend (PColorSatz(RO_Buf), @Color_R);
    end;
    if UntBufL < MaxPoi then begin
      FillZeile(RU_Buf, Farbe_, tempR);
      if Color_R.CS_alpha > 20 then PixelBlend (PColorSatz(RU_Buf), @Color_R);
    end;
    if ObBufL > FBiPOI then begin
      FillZeilelinks(LO_Buf, Farbe_, tempL);
      if Color_L.CS_alpha > 20 then PixelBlend (PColorSatz(LO_Buf), @Color_L);
    end;
    if UntBufL < MaxPoi then begin
      FillZeilelinks(LU_Buf, Farbe_, tempL);
      if Color_L.CS_alpha > 20 then PixelBlend (PColorSatz(LU_Buf), @Color_L);
   end;
    inc(UntBufL, FBiBr);
    dec(ObBufL, FBiBr);
  end;
  UntBufR := UntBufL;
  ObBufR := ObBufL;
  For i := 1 to 200000 do begin
    RU_Buf := UntBufR;
    LU_Buf := UntBufL;
    RO_Buf := ObBufR;
    LO_Buf := ObBufL;
    BB := i / Faktor;
    A2_ := bB * bB;
    b2 := c2 - a2_;             //b2 = c2 - a2
    bb := (sqrt(b2)) ; //b  = wurzel aus b2
    Temp := trunc(bb);
    Color_.CS_alpha:= Round(255 * (bb - temp));
    if Temp + Ob  >= FBiHo then begin
      TempU:= FBiHo - Ob ;
      Color_U.CS_DW :=0;
    end else begin
      TempU:= Temp- Stufe1;
      Color_U :=Color_;
    end;
    if Ob - Temp < 0 then begin
      TempO:= Ob ;
      Color_O.CS_DW :=0;
    end else begin
      TempO:= Temp - Stufe1;
      Color_O :=Color_;
    end;
    if i + Li <= FBiBr then begin
      if tempU > 0 then FillSpalte(RU_Buf, Farbe_, tempU, FBiBr);
      if Color_U.CS_alpha > 20 then PixelBlend (PColorSatz(RU_Buf), @Color_U);
      if tempO > 0 then FillSpalteOben(RO_Buf, Farbe_, tempo, FBiBr);
      if Color_O.CS_alpha > 20 then PixelBlend (PColorSatz(RO_Buf), @Color_O);
    end;
    if Li - i >= 0 then begin
      if tempU > 0 then FillSpalte(LU_Buf, Farbe_, tempU, FBiBr);
      if Color_U.CS_alpha > 20 then PixelBlend (PColorSatz(LU_Buf), @Color_U);
      if tempO > 0 then FillSpalteOben(LO_Buf, Farbe_, tempo, FBiBr);
      if Color_O.CS_alpha > 20 then PixelBlend (PColorSatz(LO_Buf), @Color_O);
    end;
    if temp <= Stufe1 then break;
    inc(UntBufR);
    inc(ObBufR);
    dec(UntBufL);
    dec(ObBufL);
  end;
end;

procedure TAroDib.SaveToAGF(Name : PAnsiChar);
var Dat : TAroFile;
begin
  Dat := TAroFile.CreateFil(Name, Op_NeuAnlegen);
  Dat.Write(FByteAnz,4);
  Dat.Write(FBiBr,2);
  Dat.Write(FBiHo,2);
  Dat.Write(FBiPoi^, FByteAnz);
  dat.Free;
end;

procedure TAroDib.SaveToBM(Name : PAnsiChar);
var header:TBITMAPFILEHEADER;
    bmiH_ : TBitmapInfoHeader;
    l, i, k : longint;
    Dat : TAroFile;
    BiDat : PColorSatz;
    BS : ByteSatz;
begin
  Dat := TAroFile.CreateFil(Name, Op_NeuAnlegen);
  l := FByteAnz;
  With header do begin
    bfType  := $4D42; // Word;
    bfSize  := l + 56; // Dateilämnge DWORD;
    bfReserved1 := 0; //Word;
    bfReserved2 := 0; //Word;
    bfOffBits := $36;  // Begin Boilddaten   DWORD;
  end;
  Dat.Write(header, sizeof(TBITMAPFILEHEADER));//Header schreiben // 14 Bytes
  With bmiH_ do begin
    biSize    :=  $28; // : DWORD;
    biWidth   :=  FBiBr;   // Breite setzen : Longint;
    biHeight  :=  FBiHo;  // Höhe setzen   : Longint;
    biPlanes  := 1; // : Word;
    biBitCount:= 32;
    biCompression := 0;// keine kompr. DWORD;
    biSizeImage := 0;//l + 2;
    biXPelsPerMeter := $B12; // Longint;
    biYPelsPerMeter := $B12; // Longint;
    biClrUsed       := 0; // keine Farbpalette DWORD;
    biClrImportant  := 0; // DWORD;
  end;
  Dat.Write(bmiH_, $28);//TBitmapInfoHeader schreiben // 40 Bytes
  BiDat := FBiPOI;
  inc(BiDat, FBiBr * FBiHo);
  for i := 1 to FBiHo do begin  // Bitmap speichern Bild von unten nach oben !!!
    dec(BiDat, FBiBr);
    for k := 1 to FBiBr do begin
      BS.B1 := BiDat^.CS_blue;
      BS.B2 := BiDat^.CS_green;
      BS.B3 := BiDat^.CS_red;
      BS.b4 := BiDat^.CS_alpha;
      Dat.Write(BS , 4); //Farbpalette lesen  BS
      inc(BiDat);
    end;
    dec(BiDat, FBiBr);
  end;
  Dat.Free;
end;

function TAroDib.GetBGRABitmap : TBGRABitmap;
begin
  if FBGRA = Nil then FBGRA := TBGRABitmap.Create(FBiBr, FBiHo);
  Result := FBGRA;
end;

procedure TAroDib.BGRAFree;
begin
  if FBGRA <> Nil then FBGRA.Free;
  FBGRA := Nil;
end;

procedure TAroDib.CopyToBGRA;
begin
  move(FBiPOI^, FBGRA.DataByte^, FByteAnz);
end;

procedure TAroDib.CopyFromBGRA;
begin
  move(FBGRA.DataByte^, FBiPOI^, FByteAnz);
end;

procedure TAroDib.Draw(ACanvas : TCanvas);
var dest: HDC;
begin
  dest := ACanvas.Handle;
  gdk_draw_rgb_32_image(TGtkDeviceContext(dest).Drawable, TGtkDeviceContext(Dest).GC, 0,0, FBiBr, FBiHo, GDK_RGB_DITHER_NORMAL, PByte(FBiPOI), FByteZeile);
end;

procedure TAroDib.Draw(ACanvas : TCanvas; QLi, QOb, QBr, QHo, ZLi, ZOb : integer);
var PI : PColorSatz;
    dest: HDC;
begin
  if QBr < 1 then exit;
  if QHo  < 1 then exit;
  dest := ACanvas.Handle;
  PI := FBiPOI;
  INC(PI, Qob * FBiBr + Qli);
  gdk_draw_rgb_32_image(TGtkDeviceContext(dest).Drawable, TGtkDeviceContext(Dest).GC, ZLi, ZOb, QBr, QHo, GDK_RGB_DITHER_NORMAL, Pointer(pi), FByteZeile);
end;

procedure TAroDib.DrawTextLi(atx,aty, Farbe:integer; atext:string);
begin
  DrawTextLi(atx,aty, Farbe, PAnsiChar(atext));
end;

procedure TAroDib.DrawTextLi(atx,aty, Farbe:integer; atext:PAnsiChar);
var r : integer;
    RFS : TAroFontSatz;
begin
  FTextfarbe.CS_DW := Farbe;
  for r := 0 to 255 do BEGIN
    if atext[r] = #0 then exit;
    RFS  := FAktFond.CharRead(ord(atext[r]));
    With RFS do begin
      inc(RFS_y, atY);
      inC(RFS_x, atx);
      DrawChar (@RFS);
      inc(atx, RFS_advx);
    end;
  end;
end;

procedure TAroDib.DrawTextRe(Re_x,aty, Farbe:integer; atext:string);
begin
  DrawTextRe(Re_x,aty, Farbe, PAnsiChar(atext));
end;

procedure TAroDib.DrawTextRe(Re_x,aty, Farbe:integer; atext:PAnsiChar);
var  l, atx : integer;
begin
  FTextfarbe.CS_DW := Farbe;
  l := GetTextSize(PansiChar(atext));
  atx := Re_x -l -1;
  DrawTextLi(atx,aty, Farbe, atext);
end;

procedure TAroDib.DrawTextZentr(Li, Ob, Br, Ho, Farbe:integer; atext:string);
begin
  DrawTextZentr(Li, Ob, Br, Ho, Farbe, PansiChar(atext));
end;

procedure TAroDib.DrawTextZentr(Li, Ob, Br, Ho, Farbe:integer; atext:PAnsiChar);
var  l, atx, aty : integer;
begin
  FTextfarbe.CS_DW := Farbe;
  l := GetTextSize(atext);
  atx := ((Br -l) shr 1) + Li ;
  aty := ((Ho - FFontHoch) shr 1) + ob;
  DrawTextLi(atx,aty, Farbe, atext);
end;

procedure TAroDib.DrawChar (PSF : PAroFontSatz);
var Buf : PColorSatz;
    Start, Rest : integer;
    rx,ry, bb : integer;
    Datbuf : Array[0..100000] of Byte;
begin
  with PSF^ do begin
    Start := RFS_y * FBiBr + RFS_x;
    if Start < 0 then exit;

    FAktFond.Seek(RFS_buf);
    {$HINTS OFF}
    FAktFond.Read(Datbuf, RFS_BuLen);
    {$HINTS ON}
    Buf := FBiPOI;
    inc(Buf, Start);
    Rest := FBiBr - RFS_pitch;
    bb := 0;
    for ry := 1 to  RFS_zei do begin
      for rx := 1 to  RFS_pitch do begin
        if Datbuf[bb] > 230 then begin
          Buf^.CS_DW := FTextfarbe.CS_DW;
        end else if Datbuf[bb] > 20 then begin
          FTextfarbe.CS_alpha:= Datbuf[bb];
          PixelBlend (Buf, @FTextfarbe);
        end;
        inc(Buf);
        inc(BB);
      end;
      inc(Buf, Rest);
    end;
  end;
end;

procedure TAroDib.PixelBlend (Ziel, Quelle: PColorSatz);
var factor1 , factor2 : single;
    x : integer;
begin
  factor2 := Quelle^.CS_alpha / 255;
  factor1 := 1 - factor2;

  x := Round(Ziel^.CS_red* factor1 + Quelle^.CS_red * factor2);
  if x > 255 then begin
    Ziel^.CS_red := 255;
  end else begin
    Ziel^.CS_red := x;
  end;

  x := Round(Ziel^.CS_blue* factor1 + Quelle^.CS_blue * factor2);
  if x > 255 then begin
    Ziel^.CS_blue := 255;
  end else begin
    Ziel^.CS_blue := x;
  end;

  x := Round(Ziel^.CS_green* factor1 + Quelle^.CS_green * factor2);
  if x > 255 then begin
    Ziel^.CS_green := 255;
  end else begin
    Ziel^.CS_green := x;
  end;
end;

function TAroDib.GetTextSize(Txt : PAnsiChar): Integer;
var i : integer;
    RFS : TAroFontSatz;
begin
  result := 0;
  for i := 0 to 255 do begin
    if Txt[i] = #0 then exit; //ende
    if Txt[i] = #195 then continue;
    RFS  := FAktFond.CharRead(ord(Txt[i]));
    inc(Result, RFS.RFS_advx);
  end;
end;

procedure TAroDib.SetFont(hoch : integer; Bold :Boolean; Na :PAnsiChar );
begin
  FAktFond := GetFont(Na, hoch, Bold);
  FFontHoch := hoch;
end;

procedure TAroDib.SetStdFont(hoch : integer; Bold :Boolean);
begin
  FAktFond := GetFont('Std_', hoch, Bold);
  FFontHoch := hoch;
end;

//TAroDateiDib//TAroDateiDib//TAroDateiDib//TAroDateiDib//TAroDateiDib//TAroDateiDib//TAroDateiDib//TAroDateiDib//TAroDateiDib
constructor TAroDateiDib.CreateFromAGF(Name : PAnsiChar);
begin
  FDat := TAroFile.CreateFil(Name, Op_Open);
  FDat.Read(FByteAnz,4);
  FDat.Read(FBiBr,2);
  FDat.Read(FBiHo,2);
  Getmem(FBiPOI, FByteAnz);
  FDat.Read(FBiPOI^, FByteAnz);
  FPixAnz := FBiBr * FBiHo;
  FByteZeile := FBiBr * 4;
  FByteAnz := FPixAnz * 4;
end;

destructor TAroDateiDib.Destroy;
begin
  if FDat <> Nil then FBGRA.Free;
  Inherited Destroy;
end;

procedure TAroDateiDib.Nachladen;
begin
  FDat.Seek(8);
  FDat.Read(FBiPOI^, FByteAnz);
end;

const
          umlAr_C : Array[1..34] of Pansichar = ('Ä', 'Ö', 'Ü', 'ä', 'ö', 'ü', 'ß', 'é', '€','≤','✂','☎','☑','☒','✔','Ø','≥','≪','≫','½','¾','¼','¹','²','³','@',
                                                 '⅛','⅜','⅝','⅞','™','±','©','‰' );
          umlAr_I : Array[1..34] of Integer =   (132, 156, 150, 164, 182, 188, 159, 169, 172,129,130,142,145,146,148,152,165,170,171,189,190,191,178,179,180,173,
                                                 192,193,194,195,174,175,176,177 );

  {   : Array[128..255] of Pansichar = (' ','≤','✂',' ','Ä','a','b','g','p','m', //128..137    128..255
                                            'W','S ',' ',' ','☎',' ',' ','☑','☒',' ', //138..147
                                            '✔',' ','Ü',' ','Ø',' ',' ',' ','Ö',' ', // 148..157
                                            '☞','ß',' ',' ',' ',' ','ä','≥',' ',' ', // 158..167
                                            ' ','é','≪','≫','€','@','™','±','©','‰', // 168..177
                                            '¹','²','³',' ','ö',' ',' ',' ',' ',' ', // 178..187
                                            'ü','½','¾','¼','⅛','⅜','⅝','⅞',' ',' ', // 188..197
                                            ' ',' ','  ',' ',' ',' ',' ',' ',' ',' ', // 198..207
                                            ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ', // 208..217
                                            ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ', // 218..227
                                            ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ', // 228..237
                                            '',' ',' ',' ',' ',' ',' ',' ',' ',' ', // 238..247
                                            ' ',' ',' ',' ',' ',' ',' ',' ' ); // 248..255     }

          GriBu_C : Array[1..7] of Pansichar = ('a', 'b', 'g', 'p', 'm', 'W', 'S');
          GriBu_I : Array[1..7] of Integer =   (133, 134, 135, 136, 137, 138, 139);

function FondNeu(FileName: PAnsiChar; FoHo : Integer; Blt: Boolean): TFontFile;
var BM : TBGRABitmap;
    Br, BmHo, li, i, LzBreit, y_Dif,  Adv, x  : integer;
    FCharpoi : PColorSatz;
    cc : AnsiChar;
    s : string;
    AdvAr : Array [0..255] of Byte;

  procedure Charlesen(PosBM : integer);
  var spa, zei, su, LastPixZei : integer;
      BB : Array [1..255] of Byte;
      Temppoi, Zeipoi, Zeipoi_ : PColorSatz;
      RFS : TAroFontSatz;
  begin
    Zeipoi := FCharpoi; //Ecke neu holen
    with RFS do begin
      RFS_advx:= Adv;
      RFS_y := -1;
      RFS_x:= Adv;
      RFS_spa := 0;
      for Zei := 1 to BmHo do begin
        Temppoi := Zeipoi; //auf neuen Zeilenanfang
        for Spa := 1 to Adv do begin
          su := 765 - Temppoi^.CS_blue - Temppoi^.CS_green - Temppoi^.CS_red;
          if su > 30 then begin
            if RFS_y < 0 then begin //die ist ein pixel in der obersten Zeile
              RFS_y:= Zei;
              Zeipoi_ := Zeipoi;
            end;
            LastPixZei := Zei;
            if RFS_x > Spa then RFS_x:= Spa;
            if RFS_spa < Spa then RFS_spa := Spa;
          end;
        inc(Temppoi);
        end;
        inc(Zeipoi, Br);
      end;
      if RFS_y > 0 then begin
        RFS_zei := LastPixZei - RFS_y+1;
        RFS_pitch:= RFS_spa;
        RFS_BuLen := RFS_zei * RFS_spa;
        dec(RFS_y, y_Dif);
      end else begin
        RFS_zei := 0;
        RFS_y := 0;
        RFS_BuLen := 0;
        RFS_pitch:= 0;
        RFS_x:= 0;
      end;
    end;
    Result.FontCharWrite(PosBM, @RFS);
    with RFS do begin
      for Spa := 2 to RFS_x do inc(Zeipoi_);
      for Zei := 1 to RFS_zei do begin
        Temppoi := Zeipoi_; //auf neuen Zeilenanfang
        for Spa := 1 to RFS_spa do begin
          BB[Spa] := (765 -Temppoi^.CS_blue - Temppoi^.CS_green - Temppoi^.CS_red) div 3;
          inc(Temppoi);
        end;
        Result.Write(BB, Spa);
        inc(Zeipoi_, Br);
      end;
    end;
  end;

  begin
    Result := TFontFile.CreateFil(FileName, Op_NeuAnlegen);
    BmHo := FoHo + FoHo;
    Br := BmHo * 170;

    BM := TBGRABitmap.Create(Br, BmHo, BGRAWhite);
    BM.FontHeight := Foho;
    LzBreit :=  BM.TextSize('e').cx; //Pixelbreite für AdvAr
    if Blt then BM.FontStyle := [fsBold];
    for i := 0 to 255 do AdvAr [i] :=0;
    BM.TextOut(0, 0, 'T', BGRABlack,  taLeftJustify);
    cc := #32;
    Li := BmHo;
    for i := 32 to 126 do begin
      s := cc  + 'e';
      AdvAr [i] := BM.TextSize(s).cx - LzBreit;
      BM.TextOut(li, 0, cc, BGRABlack,  taLeftJustify);
      inc(li, BmHo);
      inc(cc);
    end;
    for i := 1 to 34 do begin
      x := umlAr_I[i];
      Li := (x -31 )  * BmHo;
      s := umlAr_C[i]  + 'e';
      Adv := BM.TextSize(s).cx - LzBreit;
      AdvAr [x] := Adv ;
      BM.TextOut(li, 0, umlAr_C[i], BGRABlack,  taLeftJustify);
    end;
    BM.FontName:='Symbol';
    BM.FontHeight := Foho;
    for i := 1 to 7 do begin
      x := GriBu_I[i];
      Li := ( x-31)  * BmHo;
      s := GriBu_C[i]  + 'e';
      Adv := BM.TextSize(s).cx - LzBreit;
      AdvAr [x] := Adv;
      BM.TextOut(li, -2, GriBu_C[i], BGRABlack,  taLeftJustify);
    end;
    dec(AdvAr [114] ,1);  //r
    y_Dif := 0;
    FCharpoi := PColorSatz(BM.DataByte); //li ob Ecke de BM
    inc(FCharpoi, 3);   // damit wirklich Zeichen erreicht wird und nicht schwarzer Rand!
    for i := 0 to FoHo do begin
        if FCharpoi^.CS_red > 100 then break;
        inc(FCharpoi, Br);
        inc(y_Dif);
    end;
    FCharpoi := PColorSatz(BM.DataByte); //li ob Ecke de BM
    for i := 32 to 200 do begin
      inc(FCharpoi, BmHo) ;
      Adv := AdvAr[i] ;
      if Adv > 0 then begin
        Charlesen(i);
      end;
    end;
    BM.Free;
  end;

Function GetFont(Na : PAnsiChar; H : Integer; Bold :Boolean): TFontFile;
Var i : Integer;
    ss, ss1  : Array [0..255] of AnsiChar;
    PC : PAnsiChar;

begin
  PC := StrCopy1St(ss, Na);
  if Bold then PC := StrCopy1St(PC, 'Bld_');
  PC := StrCopy2St(PC, '.', ZiffAr_2[h]);
  for i := 1 to FontAnz do begin
    with FontListe^[i] do begin
      if (FS_Hoch = h) and ( FS_Bold = Bold) then begin
        if strcomp(ss, FS_Name) = 0 then begin //datei vorhanden
          Result := FS_Font;
          exit;
        end;
      end;
    end;
  end;
  // noch nicht gefunden
  if FontAnz = FontMax then begin
    inc(FontMax, 5);
    ReallocMem(FontListe, FontMax *Sizeof(FontSatz));
  end;
  StrCopy2St(ss1, FondPfad, ss);
  inc(FontAnz);
  With FontListe^[FontAnz] do begin
    FS_Hoch := H;
    FS_Bold := Bold;
    FS_Name:= strnew(ss);
    if TestDatei(ss1) then begin //datei existiert
      FS_Font := TFontFile.CreateFil(ss1, Op_Open);
    end else begin  // datei neu erzeugen
      FS_Font := FondNeu(ss1, H, Bold);
    end;
    Result := FS_Font;
  end;
end;

procedure SetFondPfad;
Var ss : Array [0..255] of AnsiChar;
    PC : PAnsiChar;
begin
  PC := StrCopy2St(ss, ProPfad, 'fonds');
  TestDir(ss);
  AnsiCharAnhaengen(PC, '/');
  FondPfad := StrNew(ss);
end;

initialization
  FontAnz := 0;
  FontMax := 10;
  GetMem(FontListe, FontMax * sizeof(FontSatz));
  SetFondPfad;
end.

